<template>
  <v-main class="ma-2">
    <v-row class="text-center">
      <v-col>
        <v-img
          :src="require('../assets/ow.svg')"
          contain
          height="100"
        />
        <h1 class="display-1 font-weight-bold">
          {{ $route.params.pugsId.substring(0, $route.params.pugsId.indexOf('-')) }}'s Overwatch PUGs
        </h1>
      </v-col>
      <v-col>
        <div class="d-flex ml-auto low-opacity login-card">
          <div class="d-flex align-center">
            <div>
              <v-img v-if="user && user.stats.iconURL"
                height="70"
                width="70"
                :src="user.stats.iconURL"
              />
              <v-img v-else
                height="70"
                width="70"
                src="@/assets/ow_default.png"
              />
            </div>
            <div>
              <v-card-title v-if="user" class="pa-2">
                <v-img v-if="!hasPrivateProfile(user) && !hasNoPlacements(user)" height="40" width="40" :src="highestSrTierIcon(user)"/>
                {{ onlyName(user.btag) }}
              </v-card-title>
              <v-card-subtitle v-else class="pa-2">Login with Battle.net to participate</v-card-subtitle>
              <v-card-subtitle v-if="hasPrivateProfile(user)" class="pa-2">Private profile</v-card-subtitle>
              <v-card-subtitle v-else-if="hasNoPlacements(user)" class="pa-2">Unranked</v-card-subtitle>
            </div>
          </div>
          <v-card-actions class="mr-2 ml-auto">
            <v-btn v-if="!user" color="success" @click="loginBtn" :loading="loading" depressed tile large>
              <v-icon left>mdi-battlenet</v-icon>Login
            </v-btn>
            <v-btn v-if="user" color="error" @click="logoutBtn" depressed tile>
              <v-icon left>mdi-logout</v-icon> Logout
            </v-btn>
          </v-card-actions>
        </div>
      </v-col>
    </v-row>
    <v-row no-gutters class="mb-4">
      <v-col>
        <div class="d-flex low-opacity align-center top-bar">
          <div class="pa-2 no-opacity">

            <v-dialog v-if="isAdmin && pug" v-model="showSettings" max-width="390">
              <template v-slot:activator="{ on, attrs }">
                <v-btn class="ma-2" color="warning" v-bind="attrs" v-on="on" depressed tile large>
                  <v-icon left>mdi-cog</v-icon>Settings
                </v-btn>
              </template>
              <v-card>
                <v-card-title class="headline">Settings</v-card-title>
                <v-card-text>
                  Title
                  <v-text-field v-if="isAdmin" v-model="pug.title" hide-details="true" color="white" v-on:keyup.enter="submitTitle" @focus="$event.target.select()" append-icon="mdi-check" @click:append="submitTitle"></v-text-field>
                </v-card-text>
                <v-card-text>
                  Clear
                  <v-card>
                    <v-btn v-if="isAdmin && pug && (pug.red_team.length > 0 || pug.blue_team.length > 0)" class="ma-2" @click.native="clearTeams" depressed small>
                      <v-icon color="orange darken-4" left>mdi-account-multiple-remove</v-icon>Teams
                    </v-btn>
                    <v-btn v-if="isAdmin && pug && pug.user_queue.length > 0" class="ma-2" @click.native="clearQ"  depressed small>
                      <v-icon color="orange darken-4" left>mdi-account-multiple-remove</v-icon>Queue
                    </v-btn>
                  </v-card>
                </v-card-text>
                <v-card-text>
                  Admins
                  <v-card>
                    <v-list dense>
                      <v-text-field v-model="adminBtag" label="Add Admin (B-Tag)" hide-details="true" @keydown.enter="addAdminBtag" outlined shaped dense>
                        <v-fade-transition slot="append">
                          <v-icon v-if="adminBtag" @click="addAdminBtag">
                            mdi-add-circle
                          </v-icon>
                        </v-fade-transition>
                      </v-text-field>
                      <v-virtual-scroll :items="pug.admins" :item-height="35" height="120">
                        <template v-slot="{ item }">
                          <v-list-item>
                            <v-list-item-content>
                              <v-list-item-title>{{item.btag}}</v-list-item-title>
                            </v-list-item-content>
                            <v-list-item-action>
                              <v-btn depressed small @click.native="removeAdmin(item._id)">
                                <v-icon color="orange darken-4">mdi-close</v-icon>
                              </v-btn>
                            </v-list-item-action>
                          </v-list-item>
                        </template>
                      </v-virtual-scroll>
                    </v-list>
                  </v-card>
                </v-card-text>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="orange darken-4" @click="showSettings = false" text>Close</v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
            <!-- AUTOMATCH DISABLED
            <v-btn v-if="isAdmin && pug && pug.user_queue.length > 0" class="ma-2" color="primary" @click.native="autoMatch" depressed tile large>
              <v-icon left>mdi-auto-fix</v-icon>Auto-Match
            </v-btn>
             -->
          </div>
          <span>
            <span v-if="!editTitle" class="pa-2 player-font">{{pug.title}}
              <v-btn v-if="isAdmin" icon color="grey" @click="onEditTitle">
                <v-icon>mdi-pencil</v-icon>
              </v-btn>
            </span>
            <v-text-field v-if="isAdmin" v-show="editTitle" v-model="pug.title" class="player-font title-edit" color="white" v-on:keyup.enter="submitTitle" @focus="$event.target.select()" append-outer-icon="mdi-check" @click:append-outer="submitTitle" clearable></v-text-field>
          </span>
          <div class="pa-2 ml-auto">
            <v-dialog v-if="user && pug && !inQ && !inTeam" max-width="330">
              <template v-slot:activator="{ on, attrs }">
                <v-btn class="ma-2" color="success" v-bind="attrs" v-on="on" depressed tile large>
                  <v-icon left>mdi-account-multiple-plus</v-icon>Join Queue
                </v-btn>
              </template>
              <v-card>
                <v-card-title class="headline">Select roles</v-card-title>
                <v-card-text>What are your preferred roles to play?</v-card-text>
                <v-card-text>
                  <v-btn-toggle v-model="selectedRoles" color="grey darken-4" dense multiple light>
                    <v-btn color="grey darken-3" x-large dark>
                      <v-img class="ma-3" width="40" height="40" :src="dpsIcon"/>
                    </v-btn>
                    <v-btn color="grey darken-3" x-large dark>
                      <v-img class="ma-3" width="40" height="40" :src="tankIcon"/>
                    </v-btn>
                    <v-btn color="grey darken-3" x-large dark>
                      <v-img class="ma-3" width="40" height="40" :src="supportIcon"/>
                    </v-btn>
                  </v-btn-toggle>
                  <span v-if="selectedRoles.length > 0" >Selected roles: {{selectedRoleNames}}</span>
                  <div v-if="hasPrivateProfile(user) || hasNoPlacements(user)" class="mt-5">
                    <div v-if="hasPrivateProfile(user)">Your Overwatch profile is set to private. Please enter your current Skill Rating.</div>
                    <div v-else-if="hasNoPlacements(user)">You havent palyed your placement games yet. Please enter your latest season Skill Rating.</div>
                    <v-text-field class="mt-5" label="Skill Rating" type="number" max="5000" v-model="currentSr" outlined></v-text-field>
                  </div>
                </v-card-text>
                <v-card-actions>
                  <v-btn v-if="selectedRoles.length > 0 && currentSr > 1 && currentSr <= 5000" class="pa-4 ml-auto mb-2" color="green darken-1" @click="joinQueue()" text>Join queue</v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
            <v-btn v-if="user && pug && inQ && !inTeam" class="ma-2" color="warning" @click.native="leaveQ" depressed tile large>
              <v-icon left>mdi-account-multiple-minus</v-icon>Leave Queue
            </v-btn>
          </div>
        </div>
      </v-col>
    </v-row>
    <v-row no-gutters>
      <v-snackbar top left v-model="copySnackbar" timeout="1000">
        {{snackbarValue}}
      </v-snackbar>
      <v-col v-if="pug.blue_team" cols="4">
        <v-card class="pa-2 player-font text-center" color="rgb(0, 0, 25, 0.7)" tile outlined>
          BLUE-TEAM <span v-if="avgBlueSr > 0" class="hashtag">({{avgBlueSr}})</span>
        </v-card>
        <v-card v-for="player in sortedBlueTeam" :key="player._id" class="pa-1 pl-4 pr-4 d-flex align-center player-font player-card" color="rgb(0, 0, 0, 0.7)" min-height="80px" tile outlined>
          <div class="mr-3">
            <v-img width="45" height="45" :src="highestSrTierIcon(player)"/>
            <div class="d-flex justify-center">
              <v-img v-for="roleNum in player.selectedRoles" :key="roleNum" class="role-icon" :src="getRoleIconByNum(roleNum)"/>
            </div>
          </div>
          <div class="mb-n3">
            <span>{{onlyName(player.btag)}}</span><span class="hashtag">{{onlyHashtag(player.btag)}}</span>
          </div>
          <div class="ml-auto d-flex">
            <div>
              <v-tooltip top>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn color="white" v-bind="attrs" v-on="on" v-clipboard="player.btag" v-clipboard:success="copySuccess" fab x-small icon>
                    <v-icon>mdi-content-copy</v-icon>
                  </v-btn>
                </template>
                <span>Copy</span>
              </v-tooltip>
            </div>
            <div v-if="isAdmin">
              <v-menu offset-y>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn v-bind="attrs" v-on="on" icon>
                    <v-icon>mdi-dots-vertical</v-icon>
                  </v-btn>
                </template>
                <v-list dense>
                  <v-list-item v-if="canAddToRed" @click="addToRed(player._id)">
                    <v-list-item-icon>
                      <v-icon color="red" small>mdi-plus-circle</v-icon>
                    </v-list-item-icon>
                    <v-list-item-title>Move to Red</v-list-item-title>
                  </v-list-item>
                  <v-list-item @click="backToQ(player._id)">
                    <v-list-item-icon>
                      <v-icon color="yellow" small>mdi-minus-circle</v-icon>
                    </v-list-item-icon>
                    <v-list-item-title>Back to Queue</v-list-item-title>
                  </v-list-item>
                  <v-list-item @click="removePlayer(player._id)">
                    <v-list-item-icon>
                      <v-icon small>mdi-delete-forever</v-icon>
                    </v-list-item-icon>
                    <v-list-item-title>Remove</v-list-item-title>
                  </v-list-item>
                </v-list>
              </v-menu>
            </div>
          </div>
          <v-chip v-if="user && user._id === player._id" class="chip-info" color="green darken-2" x-small>You</v-chip>
        </v-card>
        <v-card v-for="n in (6 - pug.blue_team.length)" :key="n" class="pa-1 d-flex align-center justify-center" color="rgb(0, 0, 0, 0.7)" min-height="80px" tile outlined>
          <div class="player-font grey--text">
            FREE
          </div>
        </v-card>
      </v-col>
      <v-spacer></v-spacer>
      <v-col v-if="pug.red_team" cols="4">
        <v-card class="pa-2 player-font text-center" color="rgb(45, 0, 0, 0.7)" tile outlined>
          RED-TEAM <span v-if="avgRedSr > 0" class="hashtag">({{avgRedSr}})</span>
        </v-card>
        <v-card v-for="player in sortedRedTeam" :key="player._id" class="pa-1 pl-4 pr-4 d-flex align-center player-font player-card" color="rgb(0, 0, 0, 0.7)" min-height="80px" tile outlined>
          <div class="mr-3">
            <v-img width="45" height="45" :src="highestSrTierIcon(player)"/>
            <div class="d-flex justify-center">
              <v-img v-for="roleNum in player.selectedRoles" :key="roleNum" class="role-icon" :src="getRoleIconByNum(roleNum)"/>
            </div>
          </div>
          <div class="mb-n3">
            <span>{{onlyName(player.btag)}}</span><span class="hashtag">{{onlyHashtag(player.btag)}}</span>
          </div>
          <div class="ml-auto d-flex">
            <div>
              <v-tooltip top>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn color="white" v-bind="attrs" v-on="on" v-clipboard="player.btag" v-clipboard:success="copySuccess" fab x-small icon>
                    <v-icon>mdi-content-copy</v-icon>
                  </v-btn>
                </template>
                <span>Copy</span>
              </v-tooltip>
            </div>
            <div v-if="isAdmin">
              <v-menu offset-y>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn v-bind="attrs" v-on="on" icon>
                    <v-icon>mdi-dots-vertical</v-icon>
                  </v-btn>
                </template>
                <v-list dense>
                  <v-list-item v-if="canAddToBlue" @click="addToBlue(player._id)">
                    <v-list-item-icon>
                      <v-icon color="blue" small>mdi-plus-circle</v-icon>
                    </v-list-item-icon>
                    <v-list-item-title>Move to Blue</v-list-item-title>
                  </v-list-item>
                  <v-list-item @click="backToQ(player._id)">
                    <v-list-item-icon>
                      <v-icon color="yellow" small>mdi-minus-circle</v-icon>
                    </v-list-item-icon>
                    <v-list-item-title>Back to Queue</v-list-item-title>
                  </v-list-item>
                  <v-list-item @click="removePlayer(player._id)">
                    <v-list-item-icon>
                      <v-icon small>mdi-delete-forever</v-icon>
                    </v-list-item-icon>
                    <v-list-item-title>Remove</v-list-item-title>
                  </v-list-item>
                </v-list>
              </v-menu>
            </div>
          </div>
          <v-chip v-if="user && user._id === player._id" class="chip-info" color="green darken-2" x-small>You</v-chip>
        </v-card>
        <v-card v-for="n in (6 - pug.red_team.length)" :key="n" class="pa-1 d-flex align-center justify-center" color="rgb(0, 0, 0, 0.7)" min-height="80px" tile outlined>
          <div class="player-font grey--text">
            FREE
          </div>
        </v-card>
      </v-col>
      <v-spacer></v-spacer>
      <v-col cols="3">
        <v-card class="pa-2 player-font text-center" color="rgb(0, 0, 0, 0.7)" tile outlined>
          QUEUE <span class="hashtag">({{sortedUserQueue.length}})</span>
        </v-card>
        <div class="queue-box scroll">
          <v-card v-for="player in sortedUserQueue" :key="player._id" class="pa-1 pl-4 pr-4 d-flex align-center player-card" color="rgb(0, 0, 0, 0.7)" min-height="80px" tile outlined>
            <div class="mr-3">
              <v-img width="45" height="45" :src="highestSrTierIcon(player)"/>
              <div class="d-flex justify-center">
                  <v-img v-for="roleNum in player.selectedRoles" :key="roleNum" class="role-icon" :src="getRoleIconByNum(roleNum)"/>
              </div>
            </div>
            <div class="mb-n3 player-font">
              <span>{{onlyName(player.btag)}}</span>
              <span class="hashtag">{{onlyHashtag(player.btag)}}</span>
            </div>
            <div class="ml-auto d-flex">
              <div v-if="isAdmin">
                <v-tooltip v-if="canAddToBlue" top>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn color="blue" v-bind="attrs" v-on="on" @click.native="addToBlue(player._id)" fab x-small icon>
                      <v-icon>mdi-plus-circle</v-icon>
                    </v-btn>
                  </template>
                  <span>Move to Blue-Team</span>
                </v-tooltip>
                <v-tooltip v-if="canAddToRed" top>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn color="red" v-bind="attrs" v-on="on" @click.native="addToRed(player._id)" fab x-small icon>
                      <v-icon>mdi-plus-circle</v-icon>
                    </v-btn>
                  </template>
                  <span>Move to Red-Team</span>
                </v-tooltip>
              </div>
              <div>
                <v-tooltip top>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn color="white" v-bind="attrs" v-on="on" v-clipboard="player.btag" v-clipboard:success="copySuccess" fab x-small icon>
                      <v-icon>mdi-content-copy</v-icon>
                    </v-btn>
                  </template>
                  <span>Copy</span>
                </v-tooltip>
              </div>
            </div>
            <v-chip v-if="user && user._id === player._id" class="chip-info" color="green darken-2" x-small>You</v-chip>
          </v-card>
        </div>
      </v-col>
    </v-row>
    <v-row justify="center">
  </v-row>
  </v-main>
</template>

<script>
import { useActions, useState, useGetters } from '@u3u/vue-hooks';
import { ref, watch, computed } from '@vue/composition-api';
import { highestSrByPlayer, hasPrivateProfile, hasNoPlacements } from '../services/PlayerUtil';

const bronzeIcon = require('../assets/ranks/bronze.png');
const silverIcon = require('../assets/ranks/silver.png');
const goldIcon = require('../assets/ranks/gold.png');
const platinIcon = require('../assets/ranks/platin.png');
const diamondIcon = require('../assets/ranks/diamond.png');
const mastersIcon = require('../assets/ranks/masters.png');
const grandmasterIcon = require('../assets/ranks/grandmaster.png');
const t500Icon = require('../assets/ranks/t500.png');
const dpsIcon = require('../assets/roles/dps.png');
const tankIcon = require('../assets/roles/tank.png');
const supportIcon = require('../assets/roles/support.png');

export default {
  name: 'Home',
  setup(_, ctx) {
    const selectedRoles = ref([]);
    const currentSr = ref(0);
    const copySnackbar = ref(false);
    const snackbarValue = ref('');
    const editTitle = ref(false);
    const adminBtag = ref('');
    const showSettings = ref(false);
    const {
      load,
      addToQ,
      leaveQ,
      addToBlue,
      addToRed,
      removePlayer,
      clearTeams,
      clearQ,
      autoMatch,
      updateTitle,
      backToQ,
      addAdmin,
      removeAdmin,
    } = useActions('pugs', [
      'load',
      'addToQ',
      'leaveQ',
      'addToBlue',
      'addToRed',
      'removePlayer',
      'clearTeams',
      'clearQ',
      'autoMatch',
      'updateTitle',
      'backToQ',
      'addAdmin',
      'removeAdmin',
    ]);

    const { logout, login } = useActions('auth', [
      'logout',
      'login',
    ]);

    const { user, loading } = useState('auth', [
      'user',
      'loading',
    ]);

    const {
      isAdmin,
      inQ,
      inTeam,
      sortedUserQueue,
      sortedRedTeam,
      sortedBlueTeam,
      canAddToRed,
      canAddToBlue,
      avgRedSr,
      avgBlueSr,
    } = useGetters('pugs', [
      'isAdmin',
      'inQ',
      'inTeam',
      'sortedUserQueue',
      'sortedRedTeam',
      'sortedBlueTeam',
      'canAddToRed',
      'canAddToBlue',
      'avgRedSr',
      'avgBlueSr',
    ]);

    const { pug } = useState('pugs', [
      'pug',
    ]);

    load(ctx.root.$route.params.pugsId);

    function loginBtn() {
      login({ url: `${process.env.VUE_APP_OAUTH_URL}?redirect=${ctx.root.$route.params.pugsId}`, label: ctx.root.$route.params.pugsId });
    }

    function logoutBtn() {
      logout(ctx.root.$route.params.pugsId);
    }

    function onlyName(btag) {
      return btag.substring(0, btag.indexOf('#'));
    }

    function onlyHashtag(btag) {
      return btag.substring(btag.indexOf('#'));
    }

    function tierIconBySr(sr) {
      if (sr <= 1499) {
        return bronzeIcon;
      }
      if (sr <= 1999) {
        return silverIcon;
      }
      if (sr <= 2499) {
        return goldIcon;
      }
      if (sr <= 2999) {
        return platinIcon;
      }
      if (sr <= 3499) {
        return diamondIcon;
      }
      if (sr <= 3999) {
        return mastersIcon;
      }
      if (sr <= 4149) {
        return grandmasterIcon;
      }
      if (sr <= 5000) {
        return t500Icon;
      }
      return diamondIcon;
    }

    function highestSrTierIcon(player) {
      return tierIconBySr(highestSrByPlayer(player));
    }

    watch(user, () => {
      if (user.value) {
        currentSr.value = highestSrByPlayer(user.value);
      }
    });

    function joinQueue() {
      addToQ({ selectedRoles: selectedRoles.value, currentSr: currentSr.value });
    }

    function sendSnackbar(message) {
      snackbarValue.value = message;
      copySnackbar.value = true;
    }

    function mapRoleNumToName(roleNum) {
      let roleName = '';
      switch (roleNum) {
        case 0: roleName = 'DPS'; break;
        case 1: roleName = 'Tank'; break;
        case 2: roleName = 'Support'; break;
        default:
      }
      return roleName;
    }

    function getRoleIconByNum(roleNum) {
      if (roleNum === 0) {
        return dpsIcon;
      }

      if (roleNum === 1) {
        return tankIcon;
      }

      if (roleNum === 2) {
        return supportIcon;
      }
      return null;
    }

    function copySuccess() {
      sendSnackbar('BattleTag™ copied');
    }

    function onEditTitle() {
      editTitle.value = true;
    }

    async function submitTitle() {
      editTitle.value = false;
      await updateTitle();
      sendSnackbar('Title has been updated');
    }

    async function addAdminBtag() {
      const data = await addAdmin(adminBtag.value);
      if (data.message) {
        sendSnackbar(data.message);
      } else {
        adminBtag.value = '';
      }
    }

    const selectedRoleNames = computed(() => selectedRoles.value.map(mapRoleNumToName).join(', '));

    return {
      addToQ,
      user,
      loading,
      pug,
      logout,
      loginBtn,
      logoutBtn,
      isAdmin,
      inQ,
      leaveQ,
      addToBlue,
      addToRed,
      removePlayer,
      inTeam,
      clearQ,
      clearTeams,
      onlyName,
      onlyHashtag,
      highestSrTierIcon,
      dpsIcon,
      tankIcon,
      supportIcon,
      selectedRoles,
      currentSr,
      joinQueue,
      getRoleIconByNum,
      hasPrivateProfile,
      hasNoPlacements,
      copySnackbar,
      copySuccess,
      sortedUserQueue,
      sortedRedTeam,
      sortedBlueTeam,
      canAddToRed,
      canAddToBlue,
      autoMatch,
      editTitle,
      submitTitle,
      onEditTitle,
      backToQ,
      avgRedSr,
      avgBlueSr,
      selectedRoleNames,
      addAdminBtag,
      adminBtag,
      snackbarValue,
      removeAdmin,
      showSettings,
    };
  },
};
</script>
<style lang="scss">
.login-card {
  max-width: 400px;
  min-width: 400px;
  min-height: 70px;
  background: rgb(0, 0, 0, 0.2);
}

.hashtag {
  font-size: 20px;
  color: grey;
}

.role-icon {
  max-width: 16px;
}

.queue-box {
  max-height: 480px;
  overflow: auto;
}

.title-edit {
  font-size: 34px !important;
}

.top-bar {
  min-height: 76px;
}

.player-card {
  position: relative;
}

.chip-info {
  font-family: 'Roboto', sans-serif;
  position: absolute !important;
  bottom: 6px;
  right: 20px;
}
</style>
